function [obj, xArr, epsArr,KArr,KnirArr,fArr,pArr,uArr, r] =...
    makeKalman(time,dT,MeasT,mTime,NIRtime,dArr,uArr,mini,filt,Nir,Sc,B0,C0,Rs)

nSim   = length(time);     % Number of simulation steps
filter = filt;

nState = 8;
nBeta  = 0;
nPar   = 2;

fVec   = zeros(nState,1);
xV     = zeros(nState,1);
pArr   = zeros(nSim,nPar);
epsArr = zeros(nSim,2);
Fi     = zeros(nState,nState);
fArr   = zeros(nState,nState,nSim);

xVB     = zeros(nState+nBeta,1);
xArr    = zeros(nSim,nState+nBeta);
KArr    = zeros(nSim,nState+nBeta);
KnirArr = zeros(nSim,nState+nBeta);

teller=2;

obj    = 0.0;
kabs   = mini.kabs;
kempt  = mini.kemp;
Sss    = mini.Sss;

xV(1)  = mini.Gs;
xV(2)  = mini.Xs;
xV(3)  = Sss;
xV(4)  = Sss;
xV(5)  = 0.0;
xV(6)  = 0.0;
xV(7)  = 0.0;
xV(8)  = 0.0;

xHat   = xV;
xVB    = [xV];
xHatB  = xVB;
fY     = 0.0;



Dmat = [1 0 0 0 0 0 0 0];
DB   = [Dmat zeros(1, nBeta)];
Wmat = 100.001;
Vmat = dT*diag([0.0 1e-6 0.01 0.01 1e8 10 0.01 0.0]);
VB   = [Vmat zeros(nState, nBeta) zeros(nBeta, nState) dT*0.0e-12*eye(nBeta)];
Xbar = diag([10 0.00001 0.01 0.01 1000 0.1 0.1 0.0]);
Xhat = Xbar;
XBB  = Xbar;
XHB  = [Xbar zeros(nState,nBeta) zeros(nBeta,nState) 1.0e-10*eye(nBeta)];




nirNxt = 1;
bgNxt  = 1;
nirM   = mini.Gb;

for i=1:nSim,
    
    %% BEGIN Estimator
    %   x1 = Plasma glucose
    %   x2 = Remote insuline action
    %   x3 = Plasma insuline
    %   x4 = Delayed insulin 1
    %   x5 = Delayed insulin 2
    %   x6 = Delayed insulin 3
    %   x7 = Stomach solid content
    %   x8 = Stomach liquid content
    %   x9 = Gut content
    
    %% Fvector
    xDel    = ones(nState,1);
    
    nComp = nState;
    if filter == 0; nComp = 0; end
    
    for j=0:nComp,
        if (j > 0)
            xV(j) = xV(j)+xDel(j);
        end
        
        % Function parameters
        Ra   = mini.f*mini.kabs*xV(6);    % Ra in mg/min
        Y    = dArr(i,2);
        fY   = Y^mini.nPot/(mini.aHR^mini.nPot+Y^mini.nPot);
        
        % Plasma insulin
        hlp     = 1+exp((mini.C1-xV(1))/mini.a1);
        iOwn    = mini.Rm/hlp;
        Iact = (xV(4)/mini.Td+iOwn+xV(7))/(mini.n*mini.Vi);
        % Glucose dynamics
        fVec(1) = -(mini.p1+(1.0+mini.alfa*xV(8))*xV(2))*xV(1)- ...
            mini.beta*Y*xV(1)+mini.p1*mini.Gb+Ra/mini.Vp;
        % Remote insuline
        fVec(2) = -mini.p2*xV(2)+mini.p3*(Iact-mini.Ib);
        
        % Delayed insulin
        fVec(3) = uArr(i,1)+mini.Ub-xV(3)/mini.Td;
        fVec(4) = (xV(3)-xV(4))/mini.Td;
        
        % Meal/gut dynamics
        fVec(5) = -kempt*xV(5)+dArr(i,1);
        fVec(6) = -kabs*xV(6)+kempt*xV(5);
        fVec(7) = 0.0;
        fVec(8) = -(fY+1.0/mini.Tex)*xV(8)+fY;
        if j == 0
            fVec0 = fVec;
        else
            xV(j)   = xV(j)-xDel(j);
            Fi(:,j) = (fVec-fVec0)/xDel(j);
        end
    end
    Fi            = eye(nState) + dT*Fi;
    fVec          = fVec0;
    
    % Compute xBar = xvB
    xV            = xV+dT*fVec;
    xVB(1:nState) = xV;
    
    %% Kalman filter update: Covariance a priori
    %Xbar = Fi*Xhat*Fi' + Vmat;
    FiB   = [Fi zeros(nState,nBeta)
             zeros(nBeta,nState) eye(nBeta)];
    XBB   = FiB*XHB*FiB' + VB;
    XHB   = XBB;
    xHatB = xVB;
    epsN  = 0.0;
    
    %% START NIR
    
    
    if mTime((teller))==i
        r=i
        z=18*MeasT(1, teller);
        DB   = Dmat;
        DXD  = DB*XBB*DB'+Wmat;
        K    = XBB*DB'/DXD; 
        xHatB = xHatB + K*(z-xVB(1)); 
        XHB = (eye(nState+nBeta)-K*DB)*XBB*(eye(nState+nBeta)-K*DB)';
        KnirArr(i,:) = K; 
        
        teller=teller+1;
    end
    
    if teller==84
        teller=83;
    end
    
%     if (nirNxt <= numel(NIRtime))
%         if (NIRtime(nirNxt) < time(i))
%             if filter > 1 && Rs(nirNxt) < 0.6
%                 DB   = Dmat;
%                 nirM  = 18.0*(Sc(nirNxt,1:10)*B0'+C0);
%                 Gmeas = nirM;
%                 epsN  = Gmeas-xVB(1);
%                 DXD  = DB*XBB*DB'+Wmat;
%                 K    = XBB*DB'/DXD;     % Kalman filter gain matrix
%                 xHatB = xHatB + K*epsN;    % Aposteriori state estimate
%                 XHB = (eye(nState+nBeta)-K*DB)*XBB*(eye(nState+nBeta)-K*DB)';
%                 KnirArr(i,:) = K;
%                 fArr(:,:,i) = Fi;
%             end
%             nirNxt = nirNxt+1;
%         end
%     end
    %% END NIR
    
 
    
    xVB = xHatB;
    xV  = xHatB(1:nState);
    
    xArr(i,:)   = xHatB;
    epsArr(i,1) = eps;
    epsArr(i,2) = epsN;
    pArr(i,1)   = nirM;
    pArr(i,2)   = Iact;
end
