function [sArr,cE,Fish,xArr,eArr,KArr,fArr,pArr,XHArr,XMArr] = senseMod(time,dT,mTime,dArr,uArr,mini)

nSim   = length(time);     % Number of simulation steps
nState = 7;
nPar   = 12;
nAux   = 1;

fVec   = zeros(nState,1);
xV     = zeros(nState,1);
pArr   = zeros(nSim,nAux);
eArr   = zeros(nSim,1);
Fi     = zeros(nState,nState);
fArr   = zeros(nState,nState,nSim);
XHArr  = zeros(nState,nSim);
XMArr  = zeros(nState,nState,nSim);
scPar  = diag([mini.p1 mini.p2 mini.p3 1/mini.Td mini.alfa mini.beta mini.aHR mini.kabs mini.kemp mini.n mini.f mini.Tex]);
sMat   = zeros(nState,nPar);
dFdP   = zeros(nState,nPar);
Fisher = zeros(nPar,nPar);
    
xArr   = zeros(nSim,nState);
KArr   = zeros(nSim,nState);
sArr   = zeros(nSim,nState,nPar);

kabs   = mini.kabs;
kemp   = mini.kemp;

xV(1)  = mini.Gb;
xV(2)  = mini.Xs;
xV(3)  = mini.Ss;
xV(4)  = mini.Ss;
xV(5)  = 0.0;
xV(6)  = 0.0;
xV(7)  = 0.0;

Dmat  = [1 zeros(1,nState-1)];
Winv  = 1.0/10;
bgNxt = 1;
mini.Ss
teller=2;
xxxV=xV;
for i=1:nSim,
    
    %% BEGIN Estimator
    %   x1 = Plasma glucose
    %   x2 = Remote insuline action
    %   x3 = Plasma insuline
    %   x4 = Delayed insulin 1
    %   x5 = Delayed insulin 2
    %   x6 = Delayed insulin 3
    %   x7 = Stomach solid content
    %   x8 = Stomach liquid content
    %   x9 = Gut content

    %% Fvector and Fi matrix
    xDel    = [1 0.1 1 1 1 1 0.01];
    U=[dArr(i,1); uArr(i,1); dArr(i,2)];
    for j=0:nState,
        if (j > 0)
            xV(j) = xV(j)+xDel(j);
        end
        
        % Function parameters
        Ra   = mini.f*kabs*xV(6);    % Ra in mg/min
        Y    = dArr(i,2);
        fY   = mini.aHR*Y^mini.nPot/(1+mini.aHR*Y^mini.nPot);
        
        % Plasma insulin
      hlp     = 1+exp((mini.C1-xV(1))/mini.a1);
        iOwn    = mini.Rm/hlp;
      %iOwn=0;
        Iact = (xV(4)/mini.Td+iOwn)/(mini.n*mini.Vi);
        % Glucose dynamics
        fVec(1) = -(mini.p1+(1.0+mini.alfa*xV(7))*xV(2))*xV(1)- ...
            mini.beta*Y*xV(1)+mini.p1*mini.Gb+Ra/mini.Vp;
        % Remote insuline
        fVec(2) = -mini.p2*xV(2)+mini.p3*(Iact-mini.Ib);
        
        % Delayed insulin
        fVec(3) = uArr(i,1)+mini.Ub-xV(3)/mini.Td;
        fVec(4) = (xV(3)-xV(4))/mini.Td;
        
        % Meal/gut dynamics
        fVec(5) = -kemp*xV(5)+dArr(i,1);
        fVec(6) = -kabs*xV(6)+kemp*xV(5);
        
        % Exercise dynamics
        fVec(7) = -(fY+1.0/mini.Tex)*xV(7)+fY;
        if j == 0
            fVec0 = fVec;
            Iact0 = Iact;
            fY0   = fY;
        else
            xV(j)   = xV(j)-xDel(j);
            Fi(:,j) = (fVec-fVec0)/xDel(j);
        end
    end
    Fi   = eye(nState) + dT*Fi;
    [t xxV]=ode15s(@(t, xxxV)fun1(t, xxxV, U), [0 dT], xxxV);
    xV=xxV(end, :);
    xxxV=xV;
    sMat = dT*(Fi*sMat + dFdP);

        
    
    
    %% Parameter sensitivity matrix
    dFdP(1,1) = (-(xV(1)-mini.Gb))*(mini.p1/xV(1));
    dFdP(2,2) = (-xV(2))*(mini.p2/xV(1));
    dFdP(2,3) = (Iact0-mini.Ib)*(mini.p3/xV(1));
    dFdP(2,4) = (mini.p3*xV(4)/(mini.Vi*mini.n))*((1/mini.Td)/xV(1));
    dFdP(3,4) = (-xV(3))*((1/mini.Td)/xV(1));
    dFdP(4,4) = (xV(3)-xV(4))*((1/mini.Td)/xV(1));
    dFdP(1,5) = (-xV(2)*xV(7)*xV(1))*(mini.alfa/xV(1));
    dFdP(1,6) = (-Y*xV(1))*(mini.beta/xV(1));
    dFdP(7,7) = (((1-xV(7))*fY0*(1-fY0)/mini.aHR))*(mini.aHR/xV(1));
    dFdP(1,8) = (mini.f*xV(6)/mini.Vp)*(mini.kabs/xV(1));
    dFdP(6,8) = (-xV(6))*(mini.kabs/xV(1));
     
    dFdP(5,9)=-xV(5)*(mini.kemp/xV(1));
    dFdP(6,9)=xV(5)*(mini.kemp/xV(1));
    dFdP(2,10)=((mini.p3*xV(4)/(mini.Vi*mini.Td))+((mini.p3*iOwn)/mini.Vi))*(mini.n/xV(1));
    dFdP(1,11)= (((mini.kabs*xV(6))/mini.Vp))*(mini.f/xV(1));
    dFdP(7,12)=((xV(7)/(mini.Tex^2)))*(mini.Tex/xV(1));
    
    %% Start MeasUse   
    eps = 0.0;
    if (bgNxt <= numel(mTime))
        if (mTime(bgNxt) < time(i))
           % Fisher = Fisher+(Dmat*sMat*(scPar)'*Winv*(Dmat*sMat*scPar);
           Fisher = Fisher+(Dmat*sMat)'*Winv*(Dmat*sMat);
            bgNxt  = bgNxt+1;
        end     
    end

    
    fArr(:,:,i)  = Fi;
    xArr(i,:)    = xV;
    pArr(i,1)    = Iact;
    sArr(i,:,:)  = sMat;
end
Fish = Fisher;
cE   = inv(Fisher);
